#!/usr/bin/perl
#
# (C) Hans-J. Barthen, DL5DI
#     Franz-Josef-Str. 20
#     D-56642 Kruft
#
# Copyright (c) 2008-2009 Hans-J. Barthen - DL5DI
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#-----------------------------------------------------------------------------
# Revision history:
#
# 20111204: initial version
# 20120413: modified to read repeater table

use DBI;

# flush after every write
$| = 1;

#-----------------------------------------------------------------------------
# hosts allowed to send updates by udp
#-----------------------------------------------------------------------------

$debug = 0;

my ($socket,$rdata);
my ($peeraddress,$peerport);
my $database = "DMR";
my $dbusr = "dmruser";
my $pw = "egal";
my $host = "127.0.0.1";
my $table = "ActRptr";

$dmrdata = "/opt/dmr/data/";
$rptrfile = $dmrdata . "dmr_rptr.txt";

$dbh = DBI->connect("DBI:mysql:database=$database:host=$host", $dbusr) or die "Can't connect to database: $DBI::errstr\n";

#-----------------------------------------------------------------------------
# read repeater-data into tables
#-----------------------------------------------------------------------------

($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=gmtime(time);
$mon++;
$year+=1900;
$timestamp = sprintf("%4.4d-%2.2d-%2.2d %2.2d:%2.2d:%2.2d",$year,$mon,$day,$hour,$min,$sec);

open(RPTRDATA, $rptrfile) or die "cannot open < input.txt: $!";

while(<RPTRDATA>){
    $usrin = $_;
    chop($usrin);
    $usrin =~ s/ \"//g;
#    $usrin =~ s/\"//g;
    $usrin =~ s/['"´`]//g;
    $usrin =~ tr/\200-\377//;
    ($rptrid,$rptrcall,$city,$cnty,$country,$qrg,$offset,$type,$cfg,$sysop,$netname,$junk) = split(/,/,$usrin,12);
    if($rptrid == ""){
	next;
    }
    $qrg =~ s/[A-Za-z ]//g;
    $offset =~ s/[A-Za-z ]//g;

    if($debug == 1){
	print "$rptrid - $rptrcall - $city - $cnty - $country - $qrg - $offset - $netname\n";
    }
    $ctry="";
    if(($rptrid >= 214000) && ($rptr_id <= 214999)){ $ctry = "ESP"; }
    if(($rptrid >= 228000) && ($rptr_id <= 228999)){ $ctry = "CHE"; }
    if(($rptrid >= 232000) && ($rptr_id <= 232999)){ $ctry = "AUT"; }
    if(($rptrid >= 242000) && ($rptr_id <= 242999)){ $ctry = "FIN"; }
    if(($rptrid >= 262000) && ($rptr_id <= 262999)){ $ctry = "DEU"; }
    if(($rptrid >= 302000) && ($rptr_id <= 302999)){ $ctry = "CAN"; }
    if(($rptrid >= 310000) && ($rptr_id <= 319999)){ $ctry = "USA"; }
    if(($rptrid >= 502000) && ($rptr_id <= 502999)){ $ctry = "MYS"; } # Malaysia 9M2
    if(($rptrid >= 505000) && ($rptr_id <= 505999)){ $ctry = "AUS"; }
    if(($rptrid >= 530000) && ($rptr_id <= 530999)){ $ctry = "NZL"; }
    if(($rptrid >= 655000) && ($rptr_id <= 655999)){ $ctry = "ZAF"; }
    $sql = "select * FROM $table where rptr_id='$rptrid'";
    $sth = $dbh->prepare($sql);
    $num = $sth->execute();
    if($sth->rows() == 0){
	$sql = "INSERT INTO `$table` (`rptr_id`,`rptr_call`,`country`,`ctry`,`qrg`,`offset`,`type`,`sysop`,`netname`,`cnty`,`city`) VALUES ('$rptrid','$rptrcall','$country','$ctry','$qrg','$offset','$type','$sysop','$netname','$cnty','$city');";
    } else {
	$sql = "UPDATE `$table` set `rptr_call`='$rptrcall',`country`='$country',`ctry`='$ctry',`qrg`='$qrg',`offset`='$offset',`type`='$type',`sysop`='$sysop',`netname`='$netname',`cnty`='$cnty',`city`='$city' where `rptr_id`='$rptrid'";
    }
    if($debug == 1){
	print $sql ."\n";
    }
    $sth = $dbh->prepare($sql);
    $sth->execute();
}
close(RPTRDATA);
$sth->finish;
$dbh->disconnect;
