#!/usr/bin/perl
#
# (C) Hans-J. Barthen, DL5DI
#     Franz-Josef-Str. 20
#     D-56642 Kruft
#
# Copyright (c) 2008-2009 Hans-J. Barthen - DL5DI
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#-----------------------------------------------------------------------------
# Revision history:
#
# 20111204: initial version

use DBI;

# flush after every write
$| = 1;

#-----------------------------------------------------------------------------
# hosts allowed to send updates by udp
#-----------------------------------------------------------------------------

$debug = 0;

my ($socket,$rdata);
my ($peeraddress,$peerport);
my $database = "DMR";
my $user = "dmruser";
my $pw = "egal";
my $host = "127.0.0.1";
my $table = "dmr_usr";

$dmrdata = "/opt/dmr/data/";
$userfile = $dmrdata . "dmr_usr.txt";

$dbh = DBI->connect("DBI:mysql:database=$database:host=$host", $user) or die "Can't connect to database: $DBI::errstr\n";

#-----------------------------------------------------------------------------
# read user- and repeater- data into tables
#-----------------------------------------------------------------------------

($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst)=gmtime(time);
$mon++;
$year+=1900;
$timestamp = sprintf("%4.4d-%2.2d-%2.2d %2.2d:%2.2d:%2.2d",$year,$mon,$day,$hour,$min,$sec);

open(USRDATA, $userfile) or die "cannot open < input.txt: $!";

while(<USRDATA>){
    $usrin = $_;
    chop($usrin);
    $usrin =~ s/ \"//g;
#    $usrin =~ s/\"//g;
    $usrin =~ s/['"´`]//g;
    ($usrid,$usrcall,$tname,$city,$cnty,$country,$radio,$rptr,$mp,$junk) = split(/,/,$usrin,10);
    $tname =~ s/[.]//g;
    $tname =~ s/Dr //g;
    ($usrname,$junk) = split(" ",$tname,2);
    if($debug == 1){
	print "$usrid - $usrcall - $name\n";
    }

    $sql = "select * FROM $table where user_id='$usrid'";
    $sth = $dbh->prepare($sql);
    $num = $sth->execute();
    if($sth->rows() == 0){
	$sql = "INSERT INTO `$table` (`date_time`,`user_id`,`call`,`name`,`city`,`cnty`,`country`,`remark`) VALUES ('$timestamp','$usrid','$usrcall','$usrname','$city','$cnty','$country','$mp');";
    } else {
	$sql = "UPDATE `$table` set `call`='$usrcall',`name`='$usrname',`city`='$city',`cnty`='$cnty',`country`='$country',`remark`='$mp' where `user_id`='$usrid'";
    }
    if($debug == 1){
	print $sql ."\n";
    }
    $sth = $dbh->prepare($sql);
    $sth->execute();
}
close(USRDATA);
$sth->finish;
$dbh->disconnect;
