<?php
#
# DMR-LastHeard-Liste
#
#
# (C) Hans-J. Barthen, DL5DI
#     Franz-Josef-Str. 20
#     D-56642 Kruft
#
# Copyright (c) 2008-2012 Hans-J. Barthen - DL5DI
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#-----------------------------------------------------------------------------
# Revision history:
#
# 03.11.2011    initial version
# 08.11.2011	ported to dmr.darc.de
# 09.11.2011	more help, links, lists
# 10.11.2011	filter for repeater implemented
# 13.10.2011	end_time of transmission added
# 04.12.2011	ported from Perl to PHP
# 01.01.2012	integrated 'net' selection and marking of local channels
# 14.02.2012	selection on timeslot added
# 15.02.2012	selection on rptr_id and rptr_call added
# 21.01.2012	info/news added
# 03.02.2012<-->file locking for counter implemented
# 09.03.2012	filter on "net" added
# 20.03.2012	net 6 / FI added
# 29.03.2012	net 7 / DE MITTE added
# ??.0?.2012	net 8 / CH added
# 14.04.2012	net 9 / ?USA? added
# 19.04.2012	net 10 / DE NORD added
# 08.06.2012	added RSS

# sample call: http://dmr.prgm.org/cgi-bin/dmr-log?30 0 DB0NG
# show "30" entries, starting with pos "0", filtered on repeater "DB0NG"


$rev = "2012/06/08";

$database = "DMR";
$user = "dmruser";
$pw = "ichbrauchkeinpasswort";
$host = "127.0.0.1";

$table1 = "Log";
$table2 = "LastHeard";
$table3 = "ActRptr";
$target = "STATUSMAIN";
$logurl = "/dmr-log.php";
$maxs = 2000;
$colw = 80;

$col[0] = "#f0f0f0";
$col[1] = "#66ccff";

include 'dmr-nets.php';

date_default_timezone_set('UTC');

$Timestamp = date("Y-m-d H:i:s",time());

# read and increase hit counter
$CNTFILE = "counter/dmr-log.cnt";
if(file_exists($CNTFILE)) {
    $cnt = file($CNTFILE);
    chop($cnt[0],"\n");
    $cnt[0] ++;
    $fp = fopen($CNTFILE, "w");
    if(flock($fp, LOCK_EX)){
	fputs($fp,"$cnt[0]");
	flock($fp, LOCK_UN);
    }
    fclose($fp);
} else {
    $fh = fopen($CNTFILE,"w");
    if($fh==false)
	die("unable to create file");
    fputs($fh, 1);
    fclose($fh);
}

##################### Number of lines, min, max, default ##############
    $sr = 0;
    $s = 0;
    $n = 30;
    $p = 0;
    $filter = "";
    $sqlf = "";

    if(isset($_GET['callsign'])){
	$scall = $_GET['callsign'];
	if($scall){
	    $filter = "callsign=$scall";
	    if(strpos($scall,"*") > 0){
		$scall = substr($scall,0,-1);
		$scall .= "%";
	    }
	    $scall = strtoupper($scall);
	    $sqlf .= "from_call like '$scall'";
	    $sr = 1;
	}
    }

    if(isset($_GET['repeater'])){
	$rcall = $_GET['repeater'];
	if($rcall){
	    if($sr == 1){
		$filter .= "&repeater=$rcall";
	    } else {
		$filter = "repeater=$rcall";
	    }
	    if(strpos($rcall,"*") > 0){
		$rcall = substr($rcall,0,-1);
		$rcall .= "%";
	    }
	    $rcall = strtoupper($rcall);
	    if($sr == 1){
		$sqlf .= " AND ";
	    }
	    $sqlf .= "rptr_call like '$rcall'";
	    $sr = 1;
	}
    }

    if(isset($_GET['rptrid'])){
	$rid = $_GET['rptrid'];
	if($rid){
	    if($sr == 1){
		$sqlf .= " AND ";
		$filter .= "&rptr_id=$rid";
	    } else {
		$filter = "rptr_id=$rid";
	    }
	    $sqlf .= "rptr_id like '$rid'";
	    $sr = 1;
	}
    }

    if(isset($_GET['n'])){
	$n = $_GET['n'];
	if(!$n) {
	    $n = 30;	# min
	}

	if($n > 100) {
	    $n = 100;	# max
	}
    }

    if(isset($_GET['s'])){
	$s = $_GET['s'];
	if(!$s){ $s = 0; }
	if($s > $maxs) {
	    $s = $maxs;	# max
	}
    }

    if(isset($_GET['po'])){
	$p = $_GET['po'];
	$port = $p + 50000;
	if($sr == 1){
	    $sqlf .= " AND ";
	    $filter .= "&";
	}
	$filter .= "po=$p";
	$sqlf .= "net='$port'";
	$sr = 1;
    } elseif(isset($_GET['net'])){
	$nt = $_GET['net'];
	$port = $prt[$nt];
	if($sr == 1){
	    $sqlf .= " AND ";
	    $filter .= "&";
	}
	$filter .= "net=$nt";
	$sqlf .= "net='$port'";
	$sr = 1;
    }

    if(isset($_GET['ts'])){
	$ts = $_GET['ts'];
	if($sr == 1){
	    $sqlf .= " AND ";
	    $filter .= "&";
	}
	$filter .= "ts=$ts";
	$sqlf .= "ts='$ts'";
	$sr = 1;
    }

#print"\ns=$s-n=$n\n";

?>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Hans-J. Barthen, DL5DI">
   <meta name="GENERATOR" content="dmr-log.php <?php echo $rev ?>>
   <META HTTP-EQUIV="Expires" CONTENT="1800">
   <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
   <META HTTP-EQUIV="Refresh" CONTENT="180">
   <title>DMR-Log</title>
   <LINK REL="stylesheet" type="text/css" href="/css/dmr.css">
</head>

<body text="#000080" link="black" alink="black" vlink="black">
    <ul class="mmenu">
    <li><a href="/dmr-lh.php" title="Last heard stations"><span>lastheard</span></a></li>
    <li><a href="/dmr-log.php" title="Log of all traffic" class="current"><span>log</span></a></li>
    <li><a href="/dmr-user.php" title="User list"><span>user</span></a></li>
    <li><a href="/dmr-net.php" title="Network list"><span>net</span></a></li>
    <li><a href="http://www.dmr-marc.net/contact.html" title="Register ID for radio at DMR-MARC website" target="_blank"><span>register</span></a></li>
    <li><a href="http://de.groups.yahoo.com/group/APCO25-DMR-DL/" title="Informationen in deutscher Sprache" target="_blank"><span>support</span></a></li>
    <li><a href="/info.html" title="Info (German)"><span>info/news</span></a></li>
    <li><a href="/hilfe.html" title="Help/Hilfe"><span>?</span></a></li>
    </ul><br clear='all'><br ALIGN='LEFT'>
    <b><font size=+1>DMR Log</font></b><br>

<?php
#----- connect db -------

    $dbh = mysql_connect($host, $user) or die ("Can't connect to database" . mysql_error());
    mysql_select_db($database,$dbh) or die ("Can't use database:" . mysql_error());

#------------------------

    if($sr == 0){
	$sql = "SELECT * FROM $table1 where hidden='0' ORDER BY date_time DESC LIMIT $n OFFSET $s";
	$sql1 = "SELECT * FROM $table1 where hidden='0'";
    } else {
	$sql = "SELECT * FROM $table1 where $sqlf AND hidden='0' ORDER BY date_time DESC LIMIT $n OFFSET $s";
	$sql1 = "SELECT * FROM $table1 where $sqlf AND hidden='0'";
    }

# print $sql;
    $sth1 = mysql_query($sql1,$dbh);
    $rows = mysql_num_rows($sth1);

    mysql_free_result($sth1);

    $sth = mysql_query($sql,$dbh);
    $num = mysql_num_rows($sth);

# Table start
?>
<table BORDER=0 BGCOLOR="white">
<tr bgcolor=black>
<th><center><font color=white><b>Nr.</b></font></center></th>
<th><a class="tooltip" href="#"><center><font color=white><b>Date</b></font></center><span><b>Date of report<br>Datum der Aussendung</b>(UTC)</span></a></th>
<th><a class="tooltip" href="#"><center><font color=white><b>Start(UTC)</b></font></center><span><b>Start of transmission<br>Start der Aussendung</b>(UTC)</span></a></th>
<th><a class="tooltip" href="#"><center><font color=white><b>End (UTC)</b></font></center><span><b>End of transmission<br>Ende der Aussendung</b>(UTC)</span></a></th>
<th><a class="tooltip" href="#"><center><font color=white><b>RSS</b></font></center><span><b>Radio Signal Strength</b>above/below roaming threshold<br><b>Signalst&auml;rke</b>&uuml;ber/unter der Roaming-Schwelle</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_users_view.php" target="_blank"><center><font color=white><b>User-ID</b></font></center><span><b>User-ID</b>Click here to get list<br><br>Hier klicken f&uuml;r Liste</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_users_view.php" target="_blank"><center><font color=white><b>User-Callsign</b></font></center><span><b>Callsign of the User<br>Rufzeichen des Benutzers</b>Field may be empty if the ID has not been registered<br>Click here to get list<br><br>Das Feld kann leer sein wenn die ID nicht registriert wurde<br>Hier klicken f&uuml;r Liste<br><br>'******' VIS OFF</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_users_view.php" target="_blank"><center><font color=white><b>User-Name</b></font></center><span><b>Name of the user<br>Name des Benutzers</b>Click here to get list<br><br>Hier klicken f&uuml;r Liste<br><br>'********' -> VIS OFF</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_repeaters_view.php" target="_blank"><center><font color=white><b>Rptr-ID</b></font></center><span><b>Repeater-ID</b>Click here to the header to get a list,<br>click to an ID to set filter.<br><br>Hier in die &Uuml;berschrift klicken f&uuml;r Liste,<br>auf eine ID klicken zum filtern.</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_repeaters_view.php" target="_blank"><center><font color=white><b>Rptr-Call</b></font></center><span><b>Repeater-Call</b>Field may be empty if the ID has not been registered<br>Click here to the header to get a list,<br>click to a callsign to set filter.<br><br>Das Feld kann leer sein wenn die ID nicht registriert wurde.<br>Hier in die &Uuml;berschrift klicken f&uuml;r Liste,<br>auf ein Call klicken zum filtern.</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_repeaters_view.php" target="_blank"><center><font color=white><b>Rptr-Location</b></font></center><span><b>Repeater-Location</b>Field may be empty if the ID has not been registered<br>Click here to get list<br><br>Das Feld kann leer sein wenn die ID nicht registriert wurde<br>Hier klicken f&uuml;r Liste</span></a></th>
<th><a class="tooltip" href="/cgi-bin/dmr-gids"><center><font color=white><b>DestID</b></font></center><span><b>Destination-ID<br>Ziel-ID</b>Group- or User-ID<br>Click here to get list<br><br>Gruppen- oder Benutzer-ID<br>Hier klicken f&uuml;r Liste<br><br>'*****' VIS OFF</span></a></th>
<th width=60><a class="tooltip" href="/cgi-bin/dmr-gids"><center><font color=white><b>Dest</b></font></center><span><b>Destination<br>Ziel</b>Group (ISO-Code) or User-Callsign<br>Click here to get list<br><br>Gruppe (ISO-Code) oder Rufzeichen<br>Hier klicken f&uuml;r Liste<br><br>'********' VIS OFF</span></a></th>
<th><a class="tooltip" href="#"><center><font color=white><b>Net</b></font></center><span><b>Network</b>all networks have<br>- TS1 common<br>- TS2 separate<br><i>(Select a network by a click to a network number)</i><br><br><b>Netzwerk</b>alle Netze nutzen<br>- TS1 gemeinsam<br>- TS2 separat<br><i>(Auswahl eines Netzes durch Klick auf Netzwerknamen)</i></span></a></th>
<th><a class="tooltip" href="#"><center><font color=white><b>TS</b></font></center><span><b>Timeslot</b>( ) currently local<br>(Select a timeslot by a click to a ts number)<br><br><b>Zeitschlitz</b>( ) aktuell unvernetzt<br>(Wahl eines Zeitschlitzes durch Klick auf eine Ziffer)</span></a></th>
<th><a class="tooltip" href="#"><center><font color=white><b>Flags</b></font></center><span><b>Flags:</b>A=Answer requested<br>G=Group Destination<br>I=Individual Dest.<br>D=Data<br>F=Final<br>V=Voice<br><br><i>Click flags to get full<br>header information</i></span></a></th>
</tr>

<?php
$lc = $s;
$ci = 0;

######################################################################
# Dynamic table
######################################################################

while ($data = mysql_fetch_array($sth)) {

    $err = 0;
    $vis = 1;
    $lc++;
    $ci++;
    if($ci > 1) { $ci = 0; }

    $flags=$data[13];
    print"<tr bgcolor=\"$col[$ci]\">";
    printf("<td ALIGN=CENTER>%4d</td>",$lc); # Zaehler
    list($start_date,$start_time) = explode(" ",$data[0],2);
    printf("<td nowrap ALIGN=CENTER>%10.10s</td>",$start_date);
    printf("<td nowrap ALIGN=CENTER>%8.8s</td>",$start_time);
    printf("<td nowrap ALIGN=CENTER>%8.8s</td>",$data[18]);
    $userid=$data[1];
    $sql2 = "SELECT vis FROM $table2 where from_id='$userid' AND hidden='0'";

    $rssi = $data[10];
    if($rssi == 1){
	printf("<td ALIGN=CENTER><img src=\"images/strong.png\" border=\"0\" alt=\"H\"</td>"); # RSSI symbol
    } else {
	printf("<td ALIGN=CENTER><img src=\"images/weak.png\" border=\"0\" alt=\"L\"</td>"); # RSSI symbol
    }

#print $sql2;
    $sth2 = mysql_query($sql2,$dbh);
    $mhrows = mysql_num_rows($sth2);

    if($mhrows > 0){
	$mhdata = mysql_fetch_row($sth2);
	$vis = $mhdata[0];
    }
    if($vis > 0){
	$usercall = $data[7]; # User-Call
	$username = $data[14]; # User-Name
    } else {
	$userid = "*******";
	$usercall = "******";
	$username = "********";
    }
    mysql_free_result($sth2);

    $rptr_id = $data[2];
    $timeslot = $data[5];
    $rptr_call = $data[8];
    printf("<td ALIGN=CENTER>%8.8s</td>",$userid); # User-ID
    printf("<td ALIGN=CENTER><a href=\"http://www.qrz.com/db/%s\" target=\"QRZ.com\">%8s</a></td>",$usercall,$usercall);
    printf("<td ALIGN=CENTER>%20.20s</td>",$username); # User-Name
    printf("<td ALIGN=CENTER><a href=\"$logurl?n=$n&rptrid=$rptr_id\">%7.7s</a></td>",$rptr_id); # Rptr-ID
    printf("<td ALIGN=CENTER><a href=\"$logurl?n=$n&repeater=$rptr_call\">%8.8s</a></td>",$rptr_call); # Rptr-Call
    printf("<td ALIGN=CENTER>%25.25s</td>",$data[15]); # Rptr-Location
    $groupid=$data[3];
    $sql2 = "SELECT vis FROM $table2 where from_id='$groupid' AND hidden='0'";
    $sth2 = mysql_query($sql2,$dbh);
    $mhrows = mysql_num_rows($sth2);
    $vis = 1;
    if($mhrows > 0){
	$mhdata = mysql_fetch_row($sth2);
	$vis = $mhdata[0];
    }
    if($vis > 0){
	$groupname = $data[9]; # User-Name
    } else {
	$groupid = "******";
	$groupname = "******";
    }
    mysql_free_result($sth2);

    $sql3 = "SELECT ts1,ts2 FROM $table3 where rptr_id='$rptr_id'";

# print $sql;

    $sth3 = mysql_query($sql3,$dbh);
    $num3 = mysql_num_rows($sth3);
    $local = 0;
    if($num3 > 0){
	$linkinfo = mysql_fetch_row($sth3);
	if($linkinfo[$timeslot-1] == 0){
	    $local = 1;
        }
    }
    printf("<td ALIGN=CENTER>%8s</td>",$groupid); # Group-ID
    if($local == 0){
	printf("<td ALIGN=CENTER>%8s</td>",$groupname); # Group-Name
    } else {
	printf("<td ALIGN=CENTER><font color=grey>(TG%8s)</font></td>",$groupid); # Group-ID
    }
    $po = $data[20];
    if($po >= 50000){
	$po = $po - 50000;
    }
    $net = $netname[$po];
    print"<td ALIGN=CENTER><a href=\"$logurl?n=$n&net=$net\">$net</a></td>"; # Network

    if($local == 0){
	if($timeslot == 1){
	    printf("<td ALIGN=CENTER><a href=\"$logurl?n=$n&ts=$timeslot\">%1s</a></td>",$timeslot); # Time-Slot
	} else {
	    printf("<td ALIGN=CENTER><a href=\"$logurl?n=$n&po=$po&ts=$timeslot\">%1s</a></td>",$timeslot); # Time-Slot
	}
    } else {
	printf("<td ALIGN=CENTER><a href=\"$logurl?n=$n&rptrid=$rptr_id&ts=$timeslot\"><font color=grey>(%1s)</font></a></td>",$timeslot); # Time-Slot
    }

#    print("<td ALIGN=CENTER>  </td>"); # RSSI
    if(strpos($flags,"IV") === 0){
	printf("<td ALIGN=CENTER bgcolor=red><FONT SIZE=-2><a href=\"/header.php?dt='$data[0]'&rid=$data[2]&seq=$data[4]&ts=$data[5]\" target=\"_blank\">%4s</a></FONT></td>",$flags); # Flags
    } else {
	printf("<td ALIGN=CENTER><FONT SIZE=-2><a href=\"/header.php?dt='$data[0]'&rid=$data[2]&seq=$data[4]&ts=$data[5]\" target=\"_blank\">%4s</a></FONT></td>",$flags); # Flags
    }
    print("</tr>");

}

# Table end

    print("</table>");

#------ DB close ------

mysql_free_result($sth);
mysql_close($dbh);

######################################################################
# Button bar
######################################################################

#
# step back
#
    print("<ul class=\"mmenu\">");
    if ($s > 1){
	$sb = 0;
	if ($s >= $n){
	    $sb = $s - $n;
	}
	$sb1 = $sb+1;
	if(strlen($filter) > 0){
    	    print"<li><a href=\"$logurl?n=$n&s=$sb&$filter\" title=\"Step back to entries $sb1 - $s\"><span>$sb1 - $s</span></a></li>";
	} else {
    	    print"<li><a href=\"$logurl?n=$n&s=$sb\" title=\"Step back to entries $sb1 - $s\"><span>$sb1 - $s</span></a></li>";
	}
    }

#
# refresh
#
    if(strlen($filter) > 0){
	print"<li><a href=\"$logurl?n=30&s=0&$filter\" title=\"Get actual last $n entries\"><span>Refresh</span></a></li>";
    } else {
	print"<li><a href=\"$logurl?n=30&s=0\" title=\"Get actual last $n entries\"><span>Refresh</span></a></li>";
    }
#
# step ahead
#
    $sn = $s+$n;
    $snm = max($rows,$maxs);
    $sne = $sn + $n;
    $sn1 = $sn + 1;
    if ($sn < $snm) {
	if(strlen($filter) > 0){
	    print"<li><a href=\"$logurl?n=$n&s=$sn&$filter\" title=\"Step ahead to entries $sn1 - $sne\"><span>$sn1 - $sne</span></a></li>";
	} else {
	    print"<li><a href=\"$logurl?n=$n&s=$sn\" title=\"Step ahead to entries $sn1 - $sne\"><span>$sn1 - $sne</span></a></li>";
	}
    }

# Table end
?>
    </ul><P>&nbsp;<P>

<?php
    print "<br><font size=-1>Status from $Timestamp UTC<br>";
    $UPDFILE = "counter/lastupdate.txt";
    if(file_exists($UPDFILE)) {
	$fp = fopen($UPDFILE, "r");
	$lupd = fgets($fp);
	chop($lupd,"\n");
	fclose($fp);
	print "<font size=-1>Last database update: " . $lupd . " UTC<br>";
    }
#    print "$cnt[0] hits since 2011-11-08<br>";
    print "<a href=\"http://download.prgm.org/dl5di-soft/dmr-monitor\" target=\"_blank\">Software-Rev.: $rev (dl5di)</a></font><br>";
?>
    <br>&nbsp;<br>

</body>
</html>
