<?php
#
# DMR-Network-List
#
#
# (C) Hans-J. Barthen, DL5DI
#     Franz-Josef-Str. 20
#     D-56642 Kruft
#
# Copyright (c) 2008-2012 Hans-J. Barthen - DL5DI
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#-----------------------------------------------------------------------------
# Revision history:
#
# 30.11.2011	initial version
# 01.01.2012	sort output for different networks
# 03.01.2012	timeout for unknown participants 3h
# 21.01.2012	info/news added
# 03.02.2012	file locking for counter implemented
# 20.03.2012	added net 6 / FI
# 29.03.2012	added net 7 / DE MITTE
# 14.04.2012	added net 8 / US-??
# 19.04.2012	added net 9 / DE NORD
# 07.06.2012	added net 0 / AT (own SMartPTT)
# 30.06.2012	cleanup, separate master flag

$rev = "2012/06/30";

$database = "DMR";
$user = "dmruser";
$pw = "ichbrauchkeinpasswort";
$host = "127.0.0.1";

$table = "ActRptr";
$target = "STATUSMAIN";
$maxs = 2000;
$colw = 80;

$col[0] = "#f0f0f0";
$col[1] = "#66ccff";
$mastercol =  "#FF9966";

#---------------------------------------------------------------
$net[0] = 50050;
$netname[0] = "AT";

$net[1] = 50003;
$netname[1] = "CH";

$net[2] = 50009;
$netname[2] = "DE NORD";

$net[3] = 50000;
$netname[3] = "DE WEST";

$net[4] = 50007;
$netname[4] = "DE MITTE";

$net[5] = 50006;
$netname[5] = "FI";

$net[6] = 50005;
$netname[6] = "US-NY";

$net[7] = 50004;
$netname[7] = "US-FL";

$net[8] = 50002;
$netname[8] = "US-IL";

$net[9] = 50008;
$netname[9] = "US-HI";

$netmax = 9;
#---------------------------------------------------------------

# activity timeout timer (in sec)
$acttot = 120;

# timeout for unknown participants (RDAC users etc.) in seconds
$tohours = 3;
$totime = $tohours * 3600;
date_default_timezone_set('UTC');

$Timestamp = date("Y-m-d H:i:s",time());

# read and increase hit counter
$CNTFILE = "counter/dmr-net.cnt";
if(file_exists($CNTFILE)) {
    $cnt = file($CNTFILE);
    chop($cnt[0],"\n");
    $cnt[0] ++;
    $fp = fopen($CNTFILE, "w");
    if(flock($fp, LOCK_EX)){
	fputs($fp,"$cnt[0]");
	flock($fp, LOCK_UN);
    }
    fclose($fp);
} else {
    $fh = fopen($CNTFILE,"w");
    if($fh==false)
	die("unable to create file");
    fputs($fh, 1);
    fclose($fh);
}

?>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Hans-J. Barthen, DL5DI">
   <meta name="GENERATOR" content="dmr-net <?php echo $rev ?>>
   <META HTTP-EQUIV="Expires" CONTENT="1800">
   <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
   <META HTTP-EQUIV="Refresh" CONTENT="300">
   <title>DMR-Network</title>
   <LINK REL="stylesheet" type="text/css" href="/css/dmr.css">
</head>

<body text="#000080" link="black" alink="black" vlink="black">
    <ul class="mmenu">
    <li><a href="/dmr-lh.php" title="Last heard stations"><span>lastheard</span></a></li>
    <li><a href="/dmr-log.php" title="Log of all traffic"><span>log</span></a></li>
    <li><a href="/dmr-user.php" title="User list"><span>user</span></a></li>
    <li><a href="/dmr-net.php" title="Network list" class="current"><span>net</span></a></li>
    <li><a href="http://www.dmr-marc.net/contact.html" title="Register ID for radio at DMR-MARC website" target="_blank"><span>register</span></a></li>
    <li><a href="http://de.groups.yahoo.com/group/APCO25-DMR-DL/" title="Informationen in deutscher Sprache" target="_blank"><span>support</span></a></li>
    <li><a href="/info.html" title="Info (German)"><span>info/news</span></a></li>
    <li><a href="/hilfe.html" title="Help/Hilfe"><span>?</span></a></li>
    </ul><br clear='all'><br ALIGN='LEFT'>

<?php
#----- connect db -------

$dbh = mysql_connect($host, $user) or die ("Can't connect to database" . mysql_error());
mysql_select_db($database,$dbh) or die ("Can't use database:" . mysql_error);

#------------------------

$n = 0;

while($n <= $netmax){


######################################################################
# Menu bar
######################################################################

# Table start

    print"<b><font size=+1>$netname[$n]</font></b><br>";
    print"<table BORDER=0 BGCOLOR=white>";
    print"<tr bgcolor=black>";
    print"<th><center></center></th>";
    print"<th><center><font color=white><b>Nr.</b></font></center></th>";
    print"<th><a class=\"tooltip\" href=\"#\"><center><font color=white><b>Date/Time (UTC)</b></font></center><span><b>Timestamp<br>Zeitstempel</b>(UTC)</span></a></th>";
    print"<th><a class=\"tooltip\" href=\"#\"><center><font color=white><b>&nbsp;</b></font></center><span><b>Country<br>Land</span></a></th>";
    print"<th width=60><a class=\"tooltip\" href=\"http://www.n6dva.org/trbo-database/trbo_repeaters_view.php\"><center><font color=white><b>Rptr-ID</b></font></center><span><b>Repeater-ID</b>- Repeater<br>- RDAC<br>- SmartPTT<br>- other connected<br>  software etc.<br>(master on red background)</span></a></th>";
    print"<th width=80><a class=\"tooltip\" href=\"http://www.n6dva.org/trbo-database/trbo_repeaters_view.php\"><center><font color=white><b>Rptr-Call</b></font></center><span><b>Repeater-Call</b>Field may be empty if the ID has not been registered<br>(master on red background)<br><br>Das Feld kann leer sein wenn die ID nicht registriert wurde<br>(Master auf rotem Hintergrund)</span></a></th>";
    print"<th width=130><a class=\"tooltip\" href=\"#\"><center><font color=white><b>Location</b></font></center><span><b>Repeater Location<br>Repeater Standort</b></span></a></th>";
    print"<th width=100><a class=\"tooltip\" href=\"#\"><center><font color=white><b>State</b></font></center><span><b>State<br>Bundesland/Kanton</b></span></a></th>";
    print"<th width=120><a class=\"tooltip\" href=\"#\"><center><font color=white><b>Country</b></font></center><span><b>Country<br>Land</b></span></a></th>";
    print"<th><a class=\"tooltip\" href=\"#\"><center><font color=white><b>Frequency</b></font></center><span><b>Transmit-Frequency<br>Sendefrequenz</b>in MHz</span></a></th>";
    print"<th><a class=\"tooltip\" href=\"#\"><center><font color=white><b>Offset</b></font></center><span><b>Duplex-Offset<br>Duplex-Ablage</b>in MHz</span></a></th>";
    print"<th><a class=\"tooltip\" href=\"#\"><center><font color=white><b>CC</b></font></center><span><b>Color Code<br>System Code</b></span></a></th>";
    print"<th><a class=\"tooltip\" href=\"#\"><center><font color=white><b>TS1</b></font></center><span><b>TS1</b>Link status of<br>timeslot 1.<br><br>Verlinkung des<br>Zeitschlitzes 1.</span></a></th>";
    print"<th><a class=\"tooltip\" href=\"#\"><center><font color=white><b>TS2</b></font></center><span><b>TS2</b>Link status of<br>timeslot 2.<br><br>Verlinkung des<br>Zeitschlitzes 2.</span></a></th>";
    print"</tr>";

    $lc = 0;
    $ci = 0;

######################################################################
# Dynamic table (part 1)
######################################################################

    $sql = "SELECT * FROM $table where hidden='0' AND net='$net[$n]' AND rptr_call!='' ORDER BY master desc,rptr_call,rptr_id";
    $sth = mysql_query($sql,$dbh);
    $num = mysql_num_rows($sth);
# print "$sql : $num Entries found<br>";
    if($num == 0){
	mysql_free_result($sth);
	$n++;
	continue;
    }

    while ($data = mysql_fetch_array($sth)) {
	$err = 0;
	if(((strtotime("now") - strtotime($data[0])) > $totime) && (!$data[2])){
	    continue;
	}

	$lc++;
	$ci++;
	if($ci > 1) { $ci = 0; }
	print"<tr bgcolor=\"$col[$ci]\">";

	if((strtotime("now") - strtotime($data[0])) > $acttot){
	    $slnk = "<img src=\"/images/20red.png\" border=0>";
	    $a = 0;
	} else {
	    $slnk = "<img src=\"/images/20green.png\" border=0>";
	    $a = 1;
	}
	$bg = "";
	print("<td ALIGN=CENTER $bg>$slnk</td>");
	printf("<td ALIGN=CENTER $bg>%4d</td>",$lc); # Zaehler
	printf("<td nowrap ALIGN=CENTER $bg>%19.19s</td>",$data[0]); # Datum/Zeit
	if($data[8]){
	    print("<td ALIGN=CENTER $bg><img src=\"/images/$data[8].png\" border=0></td>");
	} else {
	    print"<td $bg>&nbsp;</td>";
	}

	if($data[9] > 0){
	    printf("<td ALIGN=CENTER bgcolor=\"$mastercol\">%7.7s</td>",$data[1]); # Rptr-ID
	    printf("<td ALIGN=CENTER bgcolor=\"$mastercol\">%8.8s</td>",$data[2]); # Rptr-Call
	} else {
	    printf("<td ALIGN=CENTER $bg>%7.7s</td>",$data[1]); # Rptr-ID
	    printf("<td ALIGN=CENTER $bg>%8.8s</td>",$data[2]); # Rptr-Call
	}
	printf("<td ALIGN=CENTER $bg>%20.20s</td>",$data[16]); # City
	printf("<td ALIGN=CENTER $bg>%20.20s</td>",$data[15]); # County
	printf("<td ALIGN=CENTER $bg>%20.20s</td>",$data[17]); # Country
	if($data[10] > 0){
	    printf("<td ALIGN=CENTER $bg>%8.8s</td>",$data[10]); # Frequency
	    printf("<td ALIGN=CENTER $bg>%8.8s</td>",$data[11]); # Offset
	} else {
	    print("<td ALIGN=CENTER $bg>&nbsp;</td>"); # Frequency
	    print("<td ALIGN=CENTER $bg>&nbsp;</td>"); # Offset
	}

	if($data[18] > 0){
	    printf("<td ALIGN=CENTER $bg>%s</td>",$data[18]); # ColorCode
	} else {
	    printf("<td ALIGN=CENTER $bg>&nbsp;</td>",$data[18]); # ColorCode
	}

	if($a == 1){
	    if($data[3] == 1){
		print"<td ALIGN=CENTER $bg><img src=\"/images/20green.png\" border=0></td>"; # TS1 net
	    } else {
		print"<td $bg>&nbsp;</td>"; # TS1 local
	    }
	    if($data[4] == 1){
		print"<td ALIGN=CENTER $bg><img src=\"/images/20green.png\" border=0></td>"; # TS2 net
	    } else {
		print"<td $bg>&nbsp;</td>"; # TS2 local
	    }
	} else {
	    print"<td $bg>&nbsp;</td>"; # TS1
	    print"<td $bg>&nbsp;</td>"; # TS2
	}
	print("</tr>");
    }
    mysql_free_result($sth);

    print"<tr bgcolor=white><td>&nbsp;</td><td>&nbsp;</td><td>other traffic (last $tohours h):</td><td>&nbsp;</td>&nbsp;<td></td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>";

######################################################################
# Dynamic table (part 2)
######################################################################


    $sql = "SELECT * FROM $table where hidden='0' AND net='$net[$n]' AND rptr_call='' ORDER BY master desc,rptr_id";
    $sth = mysql_query($sql,$dbh);
    $num = mysql_num_rows($sth);
# print "$sql : $num Entries found<br>";
    if($num == 0){
	mysql_free_result($sth);
	$n++;
# Table end
	print"</table>";
	print"</ul><P>";
	continue;
    }

    while ($data = mysql_fetch_array($sth)) {
	$err = 0;
	if(((strtotime("now") - strtotime($data[0])) > $totime) && (!$data[2])){
	    continue;
	}

	$lc++;
	$ci++;
	if($ci > 1) { $ci = 0; }
	print"<tr bgcolor=\"$col[$ci]\">";

	if((strtotime("now") - strtotime($data[0])) > $acttot){
	    $slnk = "<img src=\"/images/20red.png\" border=0>";
	    $a = 0;
	} else {
	    $slnk = "<img src=\"/images/20green.png\" border=0>";
	    $a = 1;
	}
	$bg = "";
	if($data[9] > 0){
	    $bg = "bgcolor=\"#FF9966\"";
	}
	print("<td ALIGN=CENTER $bg>$slnk</td>");
	printf("<td ALIGN=CENTER $bg>%4d</td>",$lc); # Zaehler
	printf("<td nowrap ALIGN=CENTER $bg>%19.19s</td>",$data[0]); # Datum/Zeit
	if($data[8]){
	    print("<td ALIGN=CENTER $bg><img src=\"/images/$data[8].png\" border=0></td>");
	} else {
	    print"<td $bg>&nbsp;</td>";
	}
	printf("<td ALIGN=CENTER $bg>%7.7s</td>",$data[1]); # Rptr-ID
	printf("<td ALIGN=CENTER $bg>%8.8s</td>",$data[2]); # Rptr-Call

	printf("<td ALIGN=CENTER $bg>%20.20s</td>",$data[16]); # City
	printf("<td ALIGN=CENTER $bg>%20.20s</td>",$data[15]); # County
	printf("<td ALIGN=CENTER $bg>%20.20s</td>",$data[17]); # Country
	if($data[10] > 0){
	    printf("<td ALIGN=CENTER $bg>%8.8s</td>",$data[10]); # Frequency
	    printf("<td ALIGN=CENTER $bg>%8.8s</td>",$data[11]); # Offset
	} else {
	    print("<td ALIGN=CENTER $bg>&nbsp;</td>"); # Frequency
	    print("<td ALIGN=CENTER $bg>&nbsp;</td>"); # Offset
	}

	if($data[18] > 0){
	    printf("<td ALIGN=CENTER $bg>%s</td>",$data[18]); # ColorCode
	} else {
	    printf("<td ALIGN=CENTER $bg>&nbsp;</td>",$data[18]); # ColorCode
	}
	if($a == 1){
	    if($data[3] == 1){
		print"<td ALIGN=CENTER $bg><img src=\"/images/20green.png\" border=0></td>"; # TS1 net
	    } else {
		print"<td $bg>&nbsp;</td>"; # TS1 local
	    }
	    if($data[4] == 1){
		print"<td ALIGN=CENTER $bg><img src=\"/images/20green.png\" border=0></td>"; # TS2 net
	    } else {
		print"<td $bg>&nbsp;</td>"; # TS2 local
	    }
	} else {
	    print"<td $bg>&nbsp;</td>"; # TS1
	    print"<td $bg>&nbsp;</td>"; # TS2
	}
	print("</tr>");
    }
    mysql_free_result($sth);
    $n++;


# Table end
    print"</table>";
    print"</ul><P>";
}
#------ DB close ------

    mysql_close($dbh);

    print "<br><font size=-1>Status from $Timestamp UTC<br>";
    $UPDFILE = "counter/lastupdate.txt";
    if(file_exists($UPDFILE)) {
	$fp = fopen($UPDFILE, "r");
	$lupd = fgets($fp);
	chop($lupd,"\n");
	fclose($fp);
	print "<font size=-1>Last database update: " . $lupd . " UTC<br>";
    }
#    print "$cnt[0] hits since 2011-11-08<br>";
    print "<a href=\"http://download.prgm.org/dl5di-soft/dmr-monitor\" target=\"_blank\">Software-Rev.: $rev (dl5di)</a></font><br>";
?>

<br>&nbsp;<br>
</body>
</html>
