<?php
#
# DMR-LastHeard-Liste
#
#
# (C) Hans-J. Barthen, DL5DI
#     Franz-Josef-Str. 20
#     D-56642 Kruft
#
# Copyright (c) 2008-2012 Hans-J. Barthen - DL5DI
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#-----------------------------------------------------------------------------
# Revision history:
#
# 02.11.2011    initial version
# 03.11.2011	timeslot added
# 04.11.2011	table changed, removed dest/dest_id
# 07.11.2011	'vis' parameter und username implemented
# 08.11.2011	ported to dmr.darc.de
# 09.11.2011	more help, links, lists
# 10.11.2011	filter for user_call implemented
# 12.11.2011	indiv calls marked red
# 04.12.2011	ported from Perl to PHP
# 21.01.2012	info/news added
# 03.02.2012	file locking for counter implemented
# 20.03.2012	added net 6 FI
# 29.03.2012	added net 7 DE MITTE

# sample call: http://dmr.prgm.org/cgi-bin/dmr-log?30 0 DB0NG
# show "30" entries, starting with pos "0", filtered on repeater "DB0NG"

$rev = "2012/03/29";

$database = "DMR";
$user = "dmruser";
$pw = "ichbrauchkeinpasswort";
$host = "127.0.0.1";

$table = "LastHeard";
$weburl = "http://dmr.darc.de";
$lhurl = "/dmr-lh.php";
$logurl = "/dmr-log.php";
$usrurl = "/dmr-user.php";
$target = "STATUSMAIN";
$maxs = 2000;
$colw = 80;

$col[0] = "#f0f0f0";
$col[1] = "#66ccff";

date_default_timezone_set('UTC');

$Timestamp = date("Y-m-d H:i:s",time());

# read and increase hit counter
$CNTFILE = "counter/dmr-user.cnt";
if(file_exists($CNTFILE)) {
    $cnt = file($CNTFILE);
    chop($cnt[0],"\n");
    $cnt[0] ++;
    $fp = fopen($CNTFILE, "w");
    if(flock($fp, LOCK_EX)){
	fputs($fp,"$cnt[0]");
	flock($fp, LOCK_UN);
    }
    fclose($fp);
} else {
    $fh = fopen($CNTFILE,"w");
    if($fh==false)
	die("unable to create file");
    fputs($fh, 1);
    fclose($fh);
}

##################### Number of lines, min, max, default ##############
    $sr = 0;
    $s = 0;
    $n = 30;
    $filter = "";
    $sqlf = "";

    if(isset($_GET['callsign'])){
	$scall = $_GET['callsign'];
	if($scall){
	    $filter = "callsign=$scall";
	    if(strpos($scall,"*") > 0){
		$scall = substr($scall,0,-1);
		$scall .= "%";
	    }
	    $scall = strtoupper($scall);
	    $sqlf .= "from_call like '$scall'";
	    $sr = 1;
	}
    }

    if(isset($_GET['usrid'])){
	$usrid = $_GET['usrid'];
	if($usrid){
	    $filter .= "from_id=$usrid";
	    if(strpos($usrid,"*") > 0){
		$usrid = substr($usrid,0,-1);
		$usrid .= "%";
	    }
	    $sqlf .= "from_id like '$usrid'";
	    $sr = 1;
	}
    }

    if(isset($_GET['repeater'])){
	$rcall = $_GET['repeater'];
	if($rcall){
	    if($sr == 1){
		$filter .= "&repeater=$rcall";
	    } else {
		$filter = "repeater=$rcall";
	    }
	    if(strpos($rcall,"*") > 0){
		$rcall = substr($rcall,0,-1);
		$rcall .= "%";
	    }
	    $rcall = strtoupper($rcall);
	    if($sr == 1){
		$sqlf .= " AND ";
	    }
	    $sqlf .= "rptr_call like '$rcall'";
	    $sr = 1;
	}
    }

    if(isset($_GET['n'])){
	$n = $_GET['n'];
	if(!$n) {
	    $n = 30;	# min
	}

	if($n > 100) {
	    $n = 100;	# max
	}
    }

    if(isset($_GET['s'])){
	$s = $_GET['s'];
	if(!$s){ $s = 0; }
	if($s > 2000) {
	    $s = 2000;	# max
	}
    }

#print"\ns=$s-n=$n\n";

?>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Hans-J. Barthen, DL5DI">
   <meta name="GENERATOR" content="dmr-user.php <?php echo $rev ?>>
   <META HTTP-EQUIV="Expires" CONTENT="1800">
   <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
   <META HTTP-EQUIV="Refresh" CONTENT="180">
   <title>DMR-User</title>
   <LINK REL="stylesheet" type="text/css" href="/css/dmr.css">
</head>

<body text="#000080" link="black" alink="black" vlink="black">
    <ul class="mmenu">
    <li><a href="/dmr-lh.php" title="Last heard stations"><span>lastheard</span></a></li>
    <li><a href="/dmr-log.php" title="Log of all traffic"><span>log</span></a></li>
    <li><a href="/dmr-user.php" title="User list" class="current"><span>user</span></a></li>
    <li><a href="/dmr-net.php" title="Network list"><span>net</span></a></li>
    <li><a href="http://www.dmr-marc.net/contact.html" title="Register ID for radio at DMR-MARC website" target="_blank"><span>register</span></a></li>
    <li><a href="http://de.groups.yahoo.com/group/APCO25-DMR-DL/" title="Informationen in deutscher Sprache" target="_blank"><span>support</span></a></li>
    <li><a href="/info.html" title="Info (German)"><span>info/news</span></a></li>
    <li><a href="/hilfe.html" title="Help/Hilfe"><span>?</span></a></li>
    </ul><br clear='all'><br ALIGN='LEFT'>
    <b><font size=+1>DMR User</font></b><br>

<?php
#----- connect db -------

    $dbh = mysql_connect($host, $user) or die ("Can't connect to database" . mysql_error());
    mysql_select_db($database,$dbh) or die ("Can't use database:" . mysql_error());

#------------------------

if($sr == 0){
    $sql = "SELECT * FROM $table where hidden='0' AND vis='1' AND from_id > '1000000' and from_id < '10000000' ORDER BY from_call, from_id LIMIT $n OFFSET $s";
    $sql1 = "SELECT * FROM $table where hidden='0' AND vis='1' AND from_id > '1000000' and from_id < '10000000'";
} else {
    $sql = "SELECT * FROM $table where $sqlf AND hidden='0' AND vis='1' AND from_id > '1000000' and from_id < '10000000' ORDER BY from_call, from_id LIMIT $n OFFSET $s";
    $sql1 = "SELECT * FROM $table where $sqlf AND hidden='0' AND vis='1' AND from_id > '1000000' and from_id < '10000000'";
}
#print $sql;

    $sth1 = mysql_query($sql1,$dbh);
    $rows = mysql_num_rows($sth1);

    mysql_free_result($sth1);

    $sth = mysql_query($sql,$dbh);
    $num = mysql_num_rows($sth);

# Table start
?>
<table BORDER=0 BGCOLOR="white">
<tr bgcolor=black>
<th><center><font color=white><b>Nr.</b></font></center></th>
<th><a class="tooltip" href="#"><center><font color=white><b>Date/Time (UTC)</b></font></center><span><b>Timestamp of report<br>Zeitstempel der Meldung</b>(UTC)</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_users_view.php" target="_blank"><center><font color=white><b>User-ID</b></font></center><span><b>User-ID</b>Click here to get list<br><br>Hier klicken f&uuml;r Liste</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_users_view.php" target="_blank"><center><font color=white><b>User-Callsign</b></font></center><span><b>Callsign of the User<br>Rufzeichen des Benutzers</b>Field may be empty if the ID has not been registered<br>Click here to get list<br><br>Das Feld kann leer sein wenn die ID nicht registriert wurde<br>Hier klicken f&uuml;r Liste<br><br>'******' VIS OFF</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_users_view.php" target="_blank"><center><font color=white><b>User-Name</b></font></center><span><b>Name of the user<br>Name des Benutzers</b>Click here to get list<br><br>Hier klicken f&uuml;r Liste<br><br>'********' -> VIS OFF</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_repeaters_view.php" target="_blank"><center><font color=white><b>Rptr-ID</b></font></center><span><b>Repeater-ID</b>Click here to get list<br><br>Hier klicken f&uuml;r Liste</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_repeaters_view.php" target="_blank"><center><font color=white><b>Rptr-Call</b></font></center><span><b>Repeater-Call</b>Field may be empty if the ID has not been registered<br>Click here to get list<br><br>Das Feld kann leer sein wenn die ID nicht registriert wurde<br>Hier klicken f&uuml;r Liste</span></a></th>
<th><a class="tooltip" href="http://www.n6dva.org/trbo-database/trbo_repeaters_view.php" target="_blank"><center><font color=white><b>Rptr-Location</b></font></center><span><b>Repeater-Location</b>Field may be empty if the ID has not been registered<br>Click here to get list<br><br>Das Feld kann leer sein wenn die ID nicht registriert wurde<br>Hier klicken f&uuml;r Liste</span></a></th>
</tr>

<?php
$lc = $s;
$ci = 0;

######################################################################
# Dynamic table
######################################################################

while ($data = mysql_fetch_array($sth)) {
    $err = 0;
    $lc++;
    $ci++;
    if($ci > 1) { $ci = 0; }

    print"<tr bgcolor=\"$col[$ci]\">";
    printf("<td ALIGN=CENTER>%4d</td>",$lc); # Zaehler
    printf("<td nowrap ALIGN=CENTER>%19.19s</td>",$data[0]); # Datum/Zeit
    printf("<td ALIGN=CENTER>%8.8s</td>",$data[1]); # User-ID
    printf("<td ALIGN=CENTER><a href=\"http://www.qrz.com/db/%s\" target=\"QRZ.com\">%8s</a></td>",$data[8],$data[8]); # User-Call
    printf("<td ALIGN=CENTER>%20.20s</td>",$data[16]); # User-Name
    printf("<td ALIGN=CENTER>%7.7s</td>",$data[2]); # Rptr-ID
    printf("<td ALIGN=CENTER>%6.6s</td>",$data[9]); # Rptr-Call
    printf("<td ALIGN=CENTER>%20.20s</td>",$data[17]); # Rptr-Location
    print("</tr>");
}

# Table end

    print("</table>");

#------ DB close ------

mysql_free_result($sth);
mysql_close($dbh);

######################################################################
# Button bar
######################################################################

#
# step back
#
    print("<ul class=\"mmenu\">");

    if ($s > 0){
	$sb = 0;
	if ($s >= $n){
	    $sb = $s - $n;
	}
	$sb1 = $sb+1;
	if(strlen($filter) > 0){
    	    print"<li><a href=\"$usrurl?n=$n&s=$sb&$filter\" title=\"Step back to entries $sb1 - $s\"><span>$sb1 - $s</span></a></li>";
	} else {
    	    print"<li><a href=\"$usrurl?n=$n&s=$sb\" title=\"Step back to entries $sb1 - $s\"><span>$sb1 - $s</span></a></li>";
	}
    }

#
# refresh
#
    if(strlen($filter) > 0){
	print"<li><a href=\"$usrurl?n=30&s=0&$filter\" title=\"Get actual last $n entries\"><span>Refresh</span></a></li>";
    } else {
	print"<li><a href=\"$usrurl?n=30&s=0\" title=\"Get actual last $n entries\"><span>Refresh</span></a></li>";
    }
#
# step ahead
#
    $sn = $s+$n;
    $snm = max($rows,$maxs);
    $sne = $sn + $n;
    $sn1 = $sn + 1;
    if ($sn < $snm) {
	if(strlen($filter) > 0){
	    print"<li><a href=\"$usrurl?n=$n&s=$sn&$filter\" title=\"Step ahead to entries $sn1 - $sne\"><span>$sn1 - $sne</span></a></li>";
	} else {
	    print"<li><a href=\"$usrurl?n=$n&s=$sn\" title=\"Step ahead to entries $sn1 - $sne\"><span>$sn1 - $sne</span></a></li>";
	}
    }
    print("</ul><P>&nbsp;<P>&nbsp;<P>");

#
# search callsign
#
    print("<form action=\"$usrurl\" method=get>Callsign:<input name=\"callsign\" size=10 maxlength=6 value=\"\"><input TYPE=\"SUBMIT\" VALUE=\"SEARCH\"></form>");
    print("(Wildcard * accepted at the end)");
    print "<p>";
#
# search userid
#
    print("<form action=\"$usrurl\" method=get>User-ID:<input name=\"usrid\" size=10 maxlength=7 value=\"\"><input TYPE=\"SUBMIT\" VALUE=\"SEARCH\"></form>");
    print("(Wildcard * accepted at the end)");
    print "<p>";
#
#
#
    print "<br><font size=-1>Status from $Timestamp UTC<br>";
    $UPDFILE = "counter/lastupdate.txt";
    if(file_exists($UPDFILE)) {
	$fp = fopen($UPDFILE, "r");
	$lupd = fgets($fp);
	chop($lupd,"\n");
	fclose($fp);
	print "<font size=-1>Last database update: " . $lupd . " UTC<br>";
    }
    print"<font size=-1<i>$cnt[0] hits since 20111108</i><br>";
    print "<a href=\"http://download.prgm.org/dl5di-soft/dmr-monitor\" target=\"_blank\">Software-Rev.: $rev (dl5di)</a></font><br>";
?>
<br>&nbsp;<br>
</body>
</html>
